#include "StdAfx.h"
#include "UnAceV2J.h"
#include "ArchiveFileInfo.h"

CArchiveFileInfo::CArchiveFileInfo(void)
{
}

CArchiveFileInfo::~CArchiveFileInfo(void)
{
}

// CArchiveFileInfo o֐
void CArchiveFileInfo::SetFilename(CString strFileName) 
{
	m_Filename = strFileName;
}

CString CArchiveFileInfo::GetFilename(void)
{
	return m_Filename;
}

void CArchiveFileInfo::SetLength(DWORDLONG dwlLength)
{
	m_Length = dwlLength;
}
ULHA_INT64 CArchiveFileInfo::GetLength(void)
{
	return m_Length;
}
void CArchiveFileInfo::SetCompressedLength(DWORDLONG dwlCompressedLength)
{
	m_CompressedLength = dwlCompressedLength;
}

ULHA_INT64 CArchiveFileInfo::GetCompressedLength(void)
{
	return m_CompressedLength;
}

void CArchiveFileInfo::SetAttr(ULONG ulAttr)
{
	m_Attributes = ulAttr;
}
DWORD CArchiveFileInfo::GetAttr(void)
{
//    0x01    FA_RDONLY       ǂݍݐpt@CB
//    0x02    FA_HIDDEN       st@CB
//    0x04    FA_SYSTEM       VXet@CB
//    0x08    FA_LABEL        {[xB
//    0x10    FA_DIREC        fBNgB
//    0x20    FA_ARCH         ۑrbgB
//    0x40    FA_ENCRYPTED    pX[hی삳ꂽt@CB
	DWORD dwResult = 0;
	if (m_Attributes & FILE_ATTRIBUTE_READONLY) {
		dwResult = dwResult | FA_RDONLY;
	}
	if (m_Attributes & FILE_ATTRIBUTE_HIDDEN) {
		dwResult = dwResult | FA_HIDDEN;
	}
	if (m_Attributes & FILE_ATTRIBUTE_SYSTEM) {
		dwResult = dwResult | FA_SYSTEM;
	}
	if (m_Attributes & FILE_ATTRIBUTE_DIRECTORY) {
		dwResult = dwResult | FA_DIREC;
	}
	if (m_Attributes & FILE_ATTRIBUTE_ARCHIVE) {
		dwResult = dwResult | FA_ARCH;
	}
	if (m_Attributes & FILE_ATTRIBUTE_ENCRYPTED) {
		dwResult = dwResult | FA_ENCRYPTED;
	}

	return dwResult;
}
void CArchiveFileInfo::SetCreationDateTime(ULONG ulTime)
{
	m_CreationDateTime = COleDateTime(HIWORD(ulTime), LOWORD(ulTime)); 
}

FILETIME CArchiveFileInfo::GetCreationDateTime(void)
{
	SYSTEMTIME stCreateTime;
	FILETIME ftCreateTime;
	FILETIME ftResult;
	m_CreationDateTime.GetAsSystemTime(stCreateTime);
	SystemTimeToFileTime(&stCreateTime, &ftCreateTime);
	LocalFileTimeToFileTime(&ftCreateTime, &ftResult);

	return ftResult;
}

void CArchiveFileInfo::SetModificationDateTime(ULONG ulTime)
{
	m_ModificationDateTime = COleDateTime(HIWORD(ulTime), LOWORD(ulTime));
}

FILETIME CArchiveFileInfo::GetModificationDateTime(void)
{
	SYSTEMTIME stModificationTime;
	FILETIME ftModificationTime;
	FILETIME ftResult;
	m_ModificationDateTime.GetAsSystemTime(stModificationTime);
	SystemTimeToFileTime(&stModificationTime, &ftModificationTime);
	LocalFileTimeToFileTime(&ftModificationTime, &ftResult);

	return ftResult;
}

void CArchiveFileInfo::SetLastAccessDateTime(ULONG ulTime)
{
	m_LastAccessDateTime = COleDateTime(HIWORD(ulTime), LOWORD(ulTime));
}

FILETIME CArchiveFileInfo::GetLastAccessDateTime(void)
{
	SYSTEMTIME stLastAccessTime;
	FILETIME ftLastAccessTime;
	FILETIME ftResult;
	m_LastAccessDateTime.GetAsSystemTime(stLastAccessTime);
	SystemTimeToFileTime(&stLastAccessTime, &ftLastAccessTime);
	LocalFileTimeToFileTime(&ftLastAccessTime, &ftResult);

	return ftLastAccessTime;
}

void CArchiveFileInfo::SetCRC32(ULONG ulCRC32)
{
	m_CRC32 = ulCRC32;
}

DWORD CArchiveFileInfo::GetCRC32(void)
{
	return m_CRC32;	
}

void CArchiveFileInfo::SetMethod(ULONG ulMethod)
{
//	TRACE("Method: %d\n", ulMethod);
	// 
	// ArchivedFile->FileData->Method Ŗ߂UnAceV2.DLLł̃\bh́A
	// u|vŘAꂽlԂBȂ̂ŁALZ77V20Compression
	// ňkꂽ̂́A3ԂB
	// 炭Aȉ̉߂ŊԈႢȂƎvB

	m_Method = "stored";

	if (ulMethod & 1) {
		// LZ77
		m_Method = "-ace1-";
	}
	if (ulMethod & 2) {
		// V20Compression
		m_Method = "-ace2-";
	}
}

CString CArchiveFileInfo::GetMethod(void)
{
	return m_Method;
}
