#pragma once

#include "stdafx.h"
#include "resource.h"

class CConfirmation : public CDialogImpl<CConfirmation>, public WTL::CWinDataExchange<CConfirmation>
{
public:
	enum { IDD = IDD_CONFIRMATION };

	WTL::CString m_Version;
	WTL::CString m_Copyright;

	BEGIN_DDX_MAP(CConfirmation)
        DDX_TEXT(IDC_VERSION, m_Version)
		DDX_TEXT(IDC_COPYRIGHT, m_Copyright)
	END_DDX_MAP()

	BEGIN_MSG_MAP(CConfirmation)
        MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER_EX(IDB_NO, OnNo)
		COMMAND_ID_HANDLER_EX(IDB_NO_ALL, OnNoAll)
		COMMAND_ID_HANDLER_EX(IDB_YES, OnYes)
		COMMAND_ID_HANDLER_EX(IDB_YES_ALL, OnYesAll)
        COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
	END_MSG_MAP()

	virtual int DoModal();

    BOOL OnInitDialog(ATL::CWindow wndFocus, LPARAM lInitParam);

	void OnNo(UINT uNotifyCode, int nID, ATL::CWindow wndCtl);
	void OnNoAll(UINT uNotifyCode, int nID, ATL::CWindow wndCtl);
	void OnYes(UINT uNotifyCode, int nID, ATL::CWindow wndCtl);
	void OnYesAll(UINT uNotifyCode, int nID, ATL::CWindow wndCtl);

    void OnCancel(UINT uNotifyCode, int nID, ATL::CWindow wndCtl);

	CConfirmation(void);
	~CConfirmation(void);

	void SetFileInfo(CString strNewName, DWORDLONG dwlNewSize, ULONG ulNewTime, CString strOldName);

private:
	INT m_Result;
	CString m_NewName;
	CString m_OldName;
	DWORDLONG m_NewSize;
	ULONG m_NewTime;
};

