#include "StdAfx.h"
#include "Execute.h"
#include "UnAceV2J.h"
#include "PassDlg.h"
#include "ArchiveFileInfo.h"
#include "OpenArchive.h"
#include "Confirmation.h"
#include "Tools.h"

CExecute::CExecute(void)
: m_DlgInfo(_T(""))
, m_CmdL(FALSE)
, m_Open(FALSE)
, m_ShowDlg(FALSE)
, m_ExcludePath(FALSE)
, m_FullPathMatching(FALSE)
, m_AllYes(FALSE)
, m_AllNo(FALSE)
, m_Overwrite(FALSE)
, m_OptEA(1)
{
	_Module.g_Running = TRUE;
	_Module.g_ParenthWnd = NULL;
}

CExecute::CExecute(const HWND _hwnd)
{
	CExecute();
	_Module.g_ParenthWnd = _hwnd;
}

CExecute::~CExecute(void)
{
	FreeLoadAceDll();
	m_ProgressDlg.DestroyWindow(); 
	_Module.g_Running = FALSE;
}

//
// R}hCUnAceV2.DLLsB
//
DWORD CExecute::SetCommand(CString strCmdLine)
{
	tACEReadArchiveDataStruc ArchiveData;
	INT iResult = 0;
	m_Output = "";
	m_Open = FALSE;
	m_FileCount = 0;
	m_RequestAll = -1;
	m_FullPathMatching = FALSE;
	m_AllYes = FALSE;
	m_AllNo = FALSE;
	m_ShowDlg = TRUE;
	m_OptEA = 1;
	m_DlgInfo = "";
	m_CmdL = FALSE;


	if (!LoadAceDll()) {
		m_Output += CTools::LoadString(IDS_NO_UNACEV2);;
		return -1;
	}

	CallAceInitDll();

	CStringList argv;
	CTools::SplitCommandLine(strCmdLine, &argv); 

	ATLTRACE2("IN: " + strCmdLine + "\n");
	
	if (argv.GetCount() > 0) {
		// ꍇAeϐɒli[B
		CString strCommand = "";		// R}h
		CString strArchive = "";		// Ƀt@C
		CString strBaseDir = "";		// fBNg
		CStringList strFiles;			// Ώۏɓt@C
		m_Password = "";				// ɃpX[h
		for (int i = 0; i < (int)argv.GetCount(); i++) {
			CString strArgv = argv.GetAt(argv.FindIndex(i));
			if (i == 0) {
				if (strArgv.CompareNoCase("e") == 0) {
					strCommand = strArgv;
				} else if (strArgv.CompareNoCase("l") == 0) {
					strCommand = strArgv;
				} else if (strArgv.CompareNoCase("v") == 0) {
					strCommand = strArgv;
				} else if (strArgv.CompareNoCase("t") == 0) {
					strCommand = strArgv;
				} else if (strArgv.CompareNoCase("x") == 0) {
					strCommand = strArgv;
				} else {
					PrintHelp();
					return ERROR_COMMAND_NAME;
				}
			} else {
				// ŏɁu-vt̂̓IvVXCb`
				if (strArgv.GetAt(0) == '-') {
					// pX[h
					if (strArgv.Left(2).CompareNoCase("-p") == 0) {
						m_Password = strArgv.Mid(2);	
					} else if (strArgv.Left(2).CompareNoCase("-f") == 0) {
						m_FullPathMatching = TRUE;
						if (strArgv.GetLength() == 3) {
							if (strArgv.Mid(2).Compare("-") == 0) {
								m_FullPathMatching = FALSE;
							}
						}
					} else if (strArgv.Left(2).CompareNoCase("-y") == 0) {
						m_AllYes = TRUE;
						if (strArgv.GetLength() == 3) {
							if (strArgv.Mid(2).Compare("-") == 0) {
								m_AllYes = FALSE;
								m_AllNo = TRUE;
							}
						}
					} else if (strArgv.Left(2).CompareNoCase("-o") == 0) {
						m_Overwrite = TRUE;
						if (strArgv.GetLength() == 3) {
							if (strArgv.Mid(2).Compare("-") == 0) {
								m_Overwrite = FALSE;
							}
						}
					} else if (strArgv.CompareNoCase("--hide") == 0) {
						m_ShowDlg = FALSE;
					} else if (strArgv.CollateNoCase("--ea") == 0) {
						if (strArgv.GetLength() == 5) {
							if (strArgv.Mid(4).Compare("0") == 0) {
								m_OptEA = 0;								
							} else if (strArgv.Mid(4).Compare("1") == 0) {
								m_OptEA = 1;
							} else if (strArgv.Mid(4).Compare("2") == 0) {
								m_OptEA = 2;
							}
						}
					}
				} else {
					// Ƀt@C
					if (strArchive.GetLength() == 0) { 
						strArchive = CTools::RemoveQuoteFileName(strArgv);
					} else {
						strArgv = CTools::RemoveQuoteFileName(strArgv);
						// Ōオ'\'̏ꍇ́AfBNg
						if (strArgv.Right(1).Compare("\\") == 0) {
							strBaseDir = strArgv;
						} else {
							// ȊO̓t@C
							strFiles.AddTail(strArgv); 
						}
					}
				}
			}
		}
		m_FileList = "";
		// t@Cm_FileListɘAĂB
		if ((int)strFiles.GetCount() > 0) {
			for (int i = 0; i < (int)strFiles.GetCount(); i++) {
				CString strFile = strFiles.GetAt(strFiles.FindIndex(i));
				// X|Xt@C
				if (strFile.Left(1).Compare("@") == 0) {
					CString strResponceFile = strFile.Mid(1);
					if (CTools::FileExists(strResponceFile)) {
						// [́u"v菜
						strResponceFile = CTools::RemoveQuoteFileName(strResponceFile);
						// CRTgp
						FILE *fp;
						if (fopen_s(&fp, strResponceFile, "r") != 0) {
							char buffer[MAX_PATH + 1];
							while (fgets(buffer, sizeof(buffer), fp) != NULL) {
								buffer[sizeof(buffer)] = '\0';
								CString file = buffer;
								if (file.GetLength() > 0) {
									// [́u"v菜
									file = CTools::RemoveQuoteFileName(file);
									m_FileList.Append(file);
									m_FileList.Append("\xd");
								}
							}
							fclose(fp);
						} else {
							ATLTRACE2("Could not be opened responce file.\n");
							return ERROR_RESPONSE_READ;	
						}
					} else {
						ATLTRACE2("Response file does not exist.\n");
						return ERROR_RESPONSE_READ;	
					}
				} else {
					// [́u"v菜
					strFile = CTools::RemoveQuoteFileName(strFile);
					m_FileList.Append(strFile);
					m_FileList.Append("\xd");
				}
			}
		} else {
			m_FileList = "*";
		}

		if (strArchive.GetLength() > 0) {
			// Ƀt@Cw肳ĂB
			BOOL bExists = CTools::FileExists(strArchive);
			if (bExists) {
				LPTSTR pArchive = CStringToLPSTR(strArchive);
				ACEReadArchiveDataProc(pArchive , &ArchiveData);
				if (!ArchiveData.ArchiveData) {
					// UnAceV2.DLLɂƔFȂ
					CString strOut;
					strOut.Format(CTools::LoadString(IDS_NO_ACE_ARCHIVE), strArchive);
					m_Output += strOut;
					FreeLoadAceDll();
					return ERROR_FILE_STYLE;
				}
			} else {
				// ɂ݂ȂB
				CString strOut;
				strOut.Format(CTools::LoadString(IDS_NOT_EXIST_ACE_ARCHIVE), strArchive);
				m_Output += strOut;
				return ERROR_NOT_ARC_FILE;
			}
		} else {
			// Ƀt@Cw肳Ėꍇ̓wvo
			PrintHelp();
			return ERROR_NOT_ARC_FILE;
		}
		if (strBaseDir.GetLength() == 0) {
			// JgfBNg擾Aݒ肷B
			strBaseDir = CTools::GetCurrentDir();
			if (strBaseDir.GetLength() == 0) {
				// s(肦ȂƎvǂ...B)
				strBaseDir = ".\\";
			}
		}
		// bI
		// XeBOAvOX֘A삵ȂׁB
		if (strCommand.GetAt(0) == 'l' ||
			strCommand.GetAt(0) == 'v') {
			m_ShowDlg = FALSE;
		}
		if (m_ShowDlg) { 
			if (_Module.g_ParenthWnd == NULL) {
				_Module.g_ParenthWnd = ::GetDesktopWindow();
			}
			// 󋵕\_CAÕ[hX\
			m_ProgressDlg.Create(_Module.g_ParenthWnd);
			// [hX́AꂪȂƐeEBhEɕ\ȂB
			m_ProgressDlg.CenterWindow(_Module.g_ParenthWnd);
			// SW_SHOWNAȊOƃEBhEɃtH[JXςăAvB
			m_ProgressDlg.ShowWindow(SW_SHOWNA);
		}		
		switch (strCommand.GetAt(0)) {
			case 'e':
			{
				// fBNg΍쐬B
				// 
				// UnAceV2.DLL݂͑ȂfBNgw肵ēWJ悤Ƃ
				// G[ƂȂ̂ŁAOɃfBNg쐬B
				// ApX[h|ɂŁA_CAOLZ
				// 쐬fBNgcB̓oÔ悤łAdl̂悤
				// ł...B
				// w肵fBNg܂ő݂ĂOɒmĂ
				// Kv邪AMakeSureDirectoryPathExistsňCɍ쐬dl̈
				// ̌ۂ͎dlƂĂ...B
				if (!::MakeSureDirectoryPathExists(strBaseDir)) {
					// fBNg쐬s
					return ERROR_MAKEDIRECTORY;
				}
				m_DlgInfo = "extracting...";
				LPTSTR pArchive = CStringToLPSTR(strArchive);
				LPTSTR pBaseDir = CStringToLPSTR(strBaseDir);
				iResult = CallACEExtract(pArchive, pBaseDir, 1);
				break;
			}
			case 'l':
				m_CmdL = TRUE;
			case 'v':
			{
				LPTSTR pArchive = CStringToLPSTR(strArchive);
				iResult = CallACEList(pArchive);

				m_Output += CTools::LoadString(IDS_LIST_HEADER2);
				CString s;
				s.Format(CTools::LoadString(IDS_LIST_FOOTER), m_FileCount);
				m_Output += s;

				break;
			}
			case 't':
			{
				m_DlgInfo = "testing...";
				LPTSTR pArchive = CStringToLPSTR(strArchive);
				iResult = CallACETest(pArchive);
				break;
			}
			case 'x':
			{
				// fBNg΍쐬B
				if (!::MakeSureDirectoryPathExists(strBaseDir)) {
					// fBNg쐬s
					return ERROR_MAKEDIRECTORY;
				}
				m_DlgInfo = "extracting...";
				LPTSTR pArchive = CStringToLPSTR(strArchive);
				LPTSTR pBaseDir = CStringToLPSTR(strBaseDir);
				iResult = CallACEExtract(pArchive, pBaseDir, 0);
				break;
			}
			default:
				// ̂قŁAERROR_COMMAND_NAMEreturnĂׁAɂ͗ȂB
				ATLTRACE2("No Command\n");
		}
		if (m_ShowDlg) {
			if (m_ProgressDlg.IsAbort() == FALSE) {
				m_ProgressDlg.SetProgressPos(1000);
			}
			m_ProgressDlg.DestroyWindow();
		}
		m_ShowDlg = FALSE;
		FreeLoadAceDll();
		return ConvertAceErr(iResult);
	} else {
		PrintHelp();
	}
	return ERROR_COMMAND_NAME;
}

//
// SetCommandŎsʂ̕Wo͑̕擾
//
CString CExecute::GetOutput()
{
	m_Output.Replace("\n", "\r\n");
	return m_Output;
}

BOOL CExecute::LoadAceDll()
{
	m_AceDllInstance = ::LoadLibrary("UnAceV2.Dll");
	
	if (m_AceDllInstance) {
		if (   !(ACEInitDllProc			= (INT (__stdcall *)(pACEInitDllStruc DllData))::GetProcAddress(m_AceDllInstance, "ACEInitDll"))
			|| !(ACEReadArchiveDataProc = (INT (__stdcall *)(LPSTR ArchiveName, pACEReadArchiveDataStruc ArchiveData))::GetProcAddress(m_AceDllInstance, "ACEReadArchiveData"))
			|| !(ACEListProc            = (INT (__stdcall *)(LPSTR ArchiveName, pACEListStruc List))::GetProcAddress(m_AceDllInstance, "ACEList"))
			|| !(ACETestProc            = (INT (__stdcall *)(LPSTR ArchiveName, pACETestStruc Test))::GetProcAddress(m_AceDllInstance, "ACETest"))
			|| !(ACEExtractProc         = (INT (__stdcall *)(LPSTR ArchiveName, pACEExtractStruc Extract))::GetProcAddress(m_AceDllInstance, "ACEExtract"))) {

//			printf("\nCould not find function in UnAceV2.Dll!\n\n");
			FreeLibrary(m_AceDllInstance);
			m_AceDllInstance = NULL;
			return FALSE;
		}
	}
	return m_AceDllInstance != NULL;
}

void CExecute::FreeLoadAceDll()
{
	if (m_AceDllInstance) {
		::FreeLibrary(m_AceDllInstance);
		m_AceDllInstance = NULL;
	}
}

void CExecute::PrintHelp()
{
	// wvo(UnAce32.exȅo͂ɎĂ܂B
	m_Output =  "Usage:\n";
	m_Output += "  <command> [-<sw1> ...] <archive> [<base_dir>\\] [<files>/@<filelist>]\n\n";
	m_Output += "<Commands>                          t  Test archive integrity\n";
	m_Output += "  e  Extract files                  v  List archive (verbose)\n";
	m_Output += "  l  List archive                   x  Extract files with full path\n\n";
	m_Output += "<Switches>               (default)                                (default)\n";
	m_Output += "  c[-]  Show comments         (+)   p<pass>  Set password\n";
	m_Output += "  f[-]  Full path matching    (-)   y[-]     Assume yes on all queries (-)\n";
	m_Output += "  o[-]  Overwrite files       (-)\n\n";
	m_Output += "  x<files/@list>  Exclude <files> or files in <list> from process\n";
}

void CExecute::CallAceInitDll()
{
	tACEInitDllStruc DllData;
	
	memset(&DllData, 0, sizeof(DllData));   // set all fields to zero
	
	DllData.GlobalData.MaxArchiveTestBytes = 0x2ffFF; // search for archive
													  // header in first 256k
													  // of file
	DllData.GlobalData.MaxFileBufSize      = 0x2ffFF; // read/write buffer size
	// is 256k
	
	DllData.GlobalData.Comment.BufSize     = sizeof(CommentBuf);
	DllData.GlobalData.Comment.Buf         = CommentBuf; // set comment bufffer
	// to receive comments
	// of archive and/or
	// set comments
	
	char lpBuffer[MAX_PATH];
	DWORD dwResult = ::GetTempPath(MAX_PATH, lpBuffer);
	if (dwResult != 0) {
		DllData.GlobalData.TempDir             = lpBuffer; // set temp dir
	} else {
		DllData.GlobalData.TempDir             = "C:\\TEMP"; // set temp dir
	}

	// set callback function pointers
	DllData.GlobalData.InfoCallbackProc    = InfoProc;
	DllData.GlobalData.ErrorCallbackProc   = ErrorProc;
	DllData.GlobalData.RequestCallbackProc = RequestProc;
	DllData.GlobalData.StateCallbackProc   = StateProc;
	
	DllData.GlobalData.Obj = this;

	ACEInitDllProc(&DllData);
}

INT CExecute::CallACEList(LPSTR ArchiveName)
{
	tACEListStruc 		List;
	
	memset(&List, 0, sizeof(List));     // set all fields to zero
	
	List.Files.SourceDir   = "";        // archive main directory is
	// base directory for FileList
	List.Files.FileList    = CStringToLPSTR(m_FileList);  // set FileList
	List.Files.ExcludeList = "";        // no files to exclude
	if (m_FullPathMatching) {
		List.Files.FullMatch   = 1;
	} else {
		List.Files.FullMatch   = 0;         // also list files partially matching
	}
	// (for instance: list DIR1\TEST.DAT
	//  if FileList specifies TEST.DAT)
	
	return ACEListProc(ArchiveName, &List);
}

INT CExecute::CallACETest(LPSTR ArchiveName)
{
	tACETestStruc Test;
	
	memset(&Test, 0, sizeof(Test));     // set all fields to zero
	
	Test.Files.SourceDir   = "";        // archive main directory is
	// base directory for FileList
	Test.Files.FileList    = CStringToLPSTR(m_FileList);  // set FileList
	Test.Files.ExcludeList = "";        // no files to exclude
	if (m_FullPathMatching) {
		Test.Files.FullMatch   = 1;
	} else {
		Test.Files.FullMatch   = 0;         // also test files partially matching
	}
	CString strPassword = "";
	if (m_Password.GetLength() > 0) {
		strPassword = m_Password;
	}
	LPTSTR pPassword = CStringToLPSTR(strPassword);
	Test.DecryptPassword = pPassword;
	INT result = ACETestProc(ArchiveName, &Test);
	return result;
}

INT CExecute::CallACEExtract(LPSTR ArchiveName, LPSTR DestinationDir, BOOL DoExcludePath)
{
	tACEExtractStruc Extract;
	
	memset(&Extract, 0, sizeof(Extract));          // set all fields to zero
	
	Extract.Files.SourceDir      = "";             // archive main directory is
	// base dir for FileList
	Extract.Files.FileList       = CStringToLPSTR(m_FileList);       // set FileList
	Extract.Files.ExcludeList    = "";             // no files to exclude
	if (m_FullPathMatching) {
		Extract.Files.FullMatch      = 1;
	} else {
		Extract.Files.FullMatch      = 0;              // also extract files
	}
	// partially matching
	
	Extract.DestinationDir       = DestinationDir; // directory to extract to
	Extract.ExcludePath          = DoExcludePath;  // extract files with path?
	CString strPassword = "";
	if (m_Password.GetLength() > 0) {
		strPassword = m_Password;
	}
	LPTSTR pPassword = CStringToLPSTR(strPassword);
	Extract.DecryptPassword   = pPassword; 	
	m_BaseDir = DestinationDir;
	m_ExcludePath = DoExcludePath;

	INT result = ACEExtractProc(ArchiveName, &Extract);
	return result;
}

INT CExecute::InfoProc(pACEInfoCallbackProcStruc Info)
{
	CExecute *exec = (CExecute *)Info->Global.GlobalData->Obj;
	
	switch (Info->Global.Code) {
	case ACE_CALLBACK_INFO_FILELISTCREATE:
		// creating a file list of specified files
		{
			if (exec->m_ShowDlg) {
				exec->m_ProgressDlg.SetInfomation(CTools::LoadString(IDS_CREATING_LISTFILE));
			}
			exec->m_Output += CTools::LoadString(IDS_CREATING_LISTFILE);
			exec->m_Output += "\n";
			return ACE_CALLBACK_RETURN_OK;
		}
		break;
	case ACE_CALLBACK_INFO_FILELISTCREATEEND:
		// sent when creating the list of files is finished
		{
			if (exec->m_ShowDlg) {
				exec->m_ProgressDlg.SetInfomation(CTools::LoadString(IDS_READING_ARCHIVE));
			}
			exec->m_Output += CTools::LoadString(IDS_READING_ARCHIVE);
			exec->m_Output += "\n";
			return ACE_CALLBACK_RETURN_OK;
		}
		break;
	case ACE_CALLBACK_INFO_FILELISTADD:
		// called at creation of file list; the name
		// of the file just added to file list is
		// passed in tACECallbackRealFileStruc
//		strInfo = "adding file to file list";
		break;
	default:
//		strInfo = "";
		break;
	}
	
	return ACE_CALLBACK_RETURN_OK;
}

INT CExecute::ErrorProc(pACEErrorCallbackProcStruc Error)
{
	switch (Error->StructureType) {
	case ACE_CALLBACK_TYPE_GLOBAL:
		return HandleErrorGlobal(&Error->Global);
	case ACE_CALLBACK_TYPE_ARCHIVE:
		return HandleErrorArchive(&Error->Archive);
	case ACE_CALLBACK_TYPE_ARCHIVEDFILE:
		return HandleErrorArchivedFile(&Error->ArchivedFile);
	case ACE_CALLBACK_TYPE_REALFILE:
		return HandleErrorRealFile(&Error->RealFile);
	case ACE_CALLBACK_TYPE_SPACE:
		return HandleErrorSpace(&Error->Space);
	case ACE_CALLBACK_TYPE_SFXFILE:
		return HandleErrorSFXFile(&Error->SFXFile);
	default:
		return ACE_CALLBACK_RETURN_CANCEL;
	}
}

INT CExecute::RequestProc(pACERequestCallbackProcStruc Request)
{
	switch (Request->StructureType) {
	case ACE_CALLBACK_TYPE_GLOBAL:
		return HandleRequestGlobal(&Request->Global);
	case ACE_CALLBACK_TYPE_ARCHIVE:
		return HandleRequestArchive(&Request->Archive);
	case ACE_CALLBACK_TYPE_ARCHIVEDFILE:
		return HandleRequestArchivedFile(&Request->ArchivedFile);
	case ACE_CALLBACK_TYPE_REALFILE:
		return HandleRequestRealFile(&Request->RealFile);
	default:
		return ACE_CALLBACK_RETURN_CANCEL;
	}
}

INT CExecute::StateProc(pACEStateCallbackProcStruc State)
{
	CExecute * exec = (CExecute *)State->Archive.GlobalData->Obj;

	switch (State->StructureType) {
	case ACE_CALLBACK_TYPE_ARCHIVE:
        // type of structure is
        // tACECallbackArchiveStruc
		if (State->Archive.Code == ACE_CALLBACK_STATE_STARTARCHIVE) {
			return HandleStateStartArchive(&State->Archive);
		}
		break;
	case ACE_CALLBACK_TYPE_ARCHIVEDFILE:
        // type of structure is
        // tACECallbackArchivedFileStruc
		switch (State->ArchivedFile.Code) {
		case ACE_CALLBACK_STATE_STARTFILE:
			return HandleStateStartFile(&State->ArchivedFile);
		case ACE_CALLBACK_STATE_ENDNOCRCCHECK:
//			TRACE("ACE_CALLBACK_STATE_ENDNOCRCCHECK\n");
			break;
		}
	case ACE_CALLBACK_TYPE_PROGRESS:
        // type of structure is
        // tACECallbackProgressStruc
		if (State->Progress.Code == ACE_CALLBACK_STATE_PROGRESS) {
			if (exec->m_ShowDlg) {
				if (exec->m_ProgressDlg.IsAbort()) {	//.m_Cancel) {
					// {ɃLZ܂HƂ̊mFǂH
					exec->m_ProgressDlg.DestroyWindow();  
					return ACE_CALLBACK_RETURN_CANCEL;
				}
				UINT nRatio = State->Progress.ProgressData->TotalSize ? (UINT)(State->Progress.ProgressData->TotalProcessedSize * 1000 / State->Progress.ProgressData->TotalSize) : 0;
				exec->m_ProgressDlg.SetProgressPos(nRatio);
				CString strInfo = exec->m_DlgInfo;
				exec->m_ProgressDlg.SetInfomation(strInfo);  
			}
		}
		break;
	case ACE_CALLBACK_TYPE_CRCCHECK:
		// type of structure is
		// tACECallbackCRCCheckStruc
		if (State->CRCCheck.Code == ACE_CALLBACK_STATE_ENDCRCCHECK) {
			CString strOut;
			strOut.Format("   %s\n",
				State->CRCCheck.CRCOk ? "CRC OK" : "CRC-check error");
			exec->m_Output += strOut;
		}
		break;
	}
	return ACE_CALLBACK_RETURN_OK;
}

INT CExecute::HandleStateStartArchive(pACECallbackArchiveStruc Archive)
{
	CString     strAction;
	CExecute *exec = (CExecute *)Archive->GlobalData->Obj;
	
	ULONG ulFlag = Archive->ArchiveData->Flags;
	if (ulFlag & ACE_ARCFLAG_MAINCOMMENT) {
		ATLTRACE2("ACE_ARCFLAG_MAINCOMMENT\n");
	}
	if (ulFlag & ACE_ARCFLAG_SFX) {
		ATLTRACE2("ACE_ARCFLAG_SFX\n");
	}
	if (ulFlag & ACE_ARCFLAG_LIMITSFXJR) {
		// is an SFX archive
		// that supports 256k
		// dictionary only
		ATLTRACE2("ACE_ARCFLAG_LIMITSFXJR\n");
	}
	if (ulFlag & ACE_ARCFLAG_MULTIVOLUME) {
		ATLTRACE2("ACE_ARCFLAG_MULTIVOLUME\n");
	}
	if (ulFlag & ACE_ARCFLAG_AV) {
		// not used in ACL
		ATLTRACE2("ACE_ARCFLAG_AV\n");
	}
	if (ulFlag & ACE_ARCFLAG_RECOVERYREC) {
		ATLTRACE2("ACE_ARCFLAG_RECOVERYREC\n");
	}
	if (ulFlag & ACE_ARCFLAG_LOCK) {
		ATLTRACE2("ACE_ARCFLAG_LOCK\n");
	}
	if (ulFlag & ACE_ARCFLAG_SOLID) {
		ATLTRACE2("ACE_ARCFLAG_SOLID\n");
	}

	switch (Archive->ArchiveData->HostCreated) {
	case ACE_HOST_MSDOS:
		ATLTRACE2("ACE_HOST_MSDOS\n");
		exec->m_OSType = 0;
		break;
	case ACE_HOST_OS2:
		ATLTRACE2("ACE_HOST_OS2\n");
		exec->m_OSType = 5;
		break;
	case ACE_HOST_WIN32:
		ATLTRACE2("ACE_HOST_WIN32\n");
		exec->m_OSType = 18;
		break;
	default:
		ATLTRACE2("Unknown host os: %d\n", Archive->ArchiveData->HostCreated);
		exec->m_OSType = -1;
		break;
	}


	ATLTRACE2("VersionExtract: %d\n", Archive->ArchiveData->VersionExtract);

	switch (Archive->Operation) {
	case ACE_CALLBACK_OPERATION_LIST:
		if (exec->m_Open) {
			return ACE_CALLBACK_RETURN_OK;
		}
		{
			CString s;
			s.Format(CTools::LoadString(IDS_CONTENTS_OF_ARCHIVE), Archive->ArchiveData->ArchiveName);
			s += CTools::LoadString(IDS_LIST_HEADER1);
			s += CTools::LoadString(IDS_LIST_HEADER2);
			exec->m_Output += s;
			return ACE_CALLBACK_RETURN_OK;
		}
		break;
	case ACE_CALLBACK_OPERATION_TEST:
		{
			CString s;
			s.Format(CTools::LoadString(IDS_PROCESSING_ARCHIVE), Archive->ArchiveData->ArchiveName);
			exec->m_Output += s;
			return ACE_CALLBACK_RETURN_OK;
		}
		break;
	case ACE_CALLBACK_OPERATION_EXTRACT:
		{
			CString s;
			s.Format(CTools::LoadString(IDS_PROCESSING_ARCHIVE), Archive->ArchiveData->ArchiveName);
			exec->m_Output += s;
			return ACE_CALLBACK_RETURN_OK;
		}
		break;
	default:
		strAction = CTools::LoadString(IDS_UNKNOWN_OPERATION);
		break;
	}
	
	CString strWork;
	strWork.Format(strAction, Archive->ArchiveData->ArchiveName);
	exec->m_Output += strWork;

	return ACE_CALLBACK_RETURN_OK;
}

INT CExecute::HandleStateStartFile(pACECallbackArchivedFileStruc ArchivedFile)
{
	CString strAction;
	CExecute *exec = (CExecute *)ArchivedFile->GlobalData->Obj;
	
	switch (ArchivedFile->Operation) {
	case ACE_CALLBACK_OPERATION_LIST:
		if (exec->m_Open) {
			BOOL bEncripted = FALSE;
			if (ArchivedFile->FileData->Flags & ACE_FILEFLAG_FILECOMMENT) {
				// file has comment
				ATLTRACE2("ACE_FILEFLAG_FILECOMMENT\n");
			}
			if (ArchivedFile->FileData->Flags & ACE_FILEFLAG_SPLITBEFORE) {
				// continued from
				// previous volume
				ATLTRACE2("ACE_FILEFLAG_SPLITBEFORE\n");
			}
			if (ArchivedFile->FileData->Flags & ACE_FILEFLAG_SPLITAFTER) {
				// continued on
				// next volume
				ATLTRACE2("ACE_FILEFLAG_SPLITAFTER\n");
			}
			if (ArchivedFile->FileData->Flags & ACE_FILEFLAG_PASSWORD) {
				// is encrypted
				ATLTRACE2("ACE_FILEFLAG_PASSWORD\n");
				bEncripted = TRUE;
			}
			if (ArchivedFile->FileData->Flags & ACE_FILEFLAG_SOLID) {
				// uses data of previous
				// files (solid mode)
				ATLTRACE2("ACE_FILEFLAG_SOLID\n");
			}

			ATLTRACE2("ArchivedFile->FileData->SourceFileName = %s\n", ArchivedFile->FileData->SourceFileName);

			CArchiveFileInfo* afi = new CArchiveFileInfo();
			afi->SetFilename(ArchivedFile->FileData->SourceFileName);
			afi->SetCRC32(ArchivedFile->FileData->CRC32);
			afi->SetMethod(ArchivedFile->FileData->Method);
			afi->SetCompressedLength(ArchivedFile->FileData->CompressedSize);
			afi->SetLength(ArchivedFile->FileData->Size);
			afi->SetCreationDateTime(ArchivedFile->FileData->Time);
			afi->SetLastAccessDateTime(ArchivedFile->FileData->Time);
			afi->SetModificationDateTime(ArchivedFile->FileData->Time);
			if (bEncripted) {
				afi->SetAttr(ArchivedFile->FileData->Attributes | FILE_ATTRIBUTE_ENCRYPTED); 
			} else {
				afi->SetAttr(ArchivedFile->FileData->Attributes);
			}
			COpenArchive * oa = (COpenArchive *)exec->m_Obj; 
			oa->m_list.AddTail(afi);  
			return ACE_CALLBACK_RETURN_OK;
		}
		if (exec->m_ShowDlg) {
			exec->m_ProgressDlg.SetFileName(ArchivedFile->FileData->SourceFileName); 
		}
		{
			CString s;
			FILETIME ft;
			SYSTEMTIME st;
			WORD wRatio;
			if (::DosDateTimeToFileTime(HIWORD(ArchivedFile->FileData->Time),
										LOWORD(ArchivedFile->FileData->Time),
										&ft)) {
				::FileTimeToSystemTime(&ft, &st);  
				if (ArchivedFile->FileData->Size == 0) {
					wRatio = 0;
				} else {
					wRatio = (WORD)(ArchivedFile->FileData->CompressedSize * 100 / ArchivedFile->FileData->Size);
				}
				CString strSourceFile = ArchivedFile->FileData->SourceFileName;
				if (exec->m_CmdL) {
					// ulvR}hȂ̂Ńt@C̃pXJbgB
					int iPos = strSourceFile.ReverseFind('\\');
					if (iPos != -1) {
						if ((iPos + 1) != strSourceFile.GetLength()) {
							strSourceFile = strSourceFile.Mid(iPos + 1);
						}
					}
				}
				// "00.00.0000 00:00 12345678901 12345678901  100% DIR\FILENAME"
				s.Format(CTools::LoadString(IDS_LIST_FILE), 
							st.wDay, 
							st.wMonth, 
							(st.wYear < 2000 ? st.wYear - 1900: st.wYear - 2000), 
							st.wHour, 
							st.wMinute,
							ArchivedFile->FileData->CompressedSize,
							ArchivedFile->FileData->Size,
							wRatio,
							strSourceFile);     
				exec->m_Output += s;
				exec->m_FileCount ++;
	
				return ACE_CALLBACK_RETURN_OK;
			}
		}
		break;
	case ACE_CALLBACK_OPERATION_TEST:
		if (exec->m_Open) {
			return ACE_CALLBACK_RETURN_OK;
		}
		if (exec->m_ShowDlg) {
			exec->m_ProgressDlg.SetFileName(ArchivedFile->FileData->SourceFileName); 
		}
		{
			CString s;
			s.Format(CTools::LoadString(IDS_TESTING), ArchivedFile->FileData->SourceFileName);
			exec->m_Output += s;
			if (ArchivedFile->FileData->Size == 0) {
				exec->m_Output += CTools::LoadString(IDS_TESTING_DIR);
			}
			return ACE_CALLBACK_RETURN_OK;
		}
		break;
	case ACE_CALLBACK_OPERATION_ANALYZE:
		strAction = "Analyzing";
		break;
	case ACE_CALLBACK_OPERATION_EXTRACT:
		if (exec->m_Open) {
			return ACE_CALLBACK_RETURN_OK;
		}
		if (exec->m_ShowDlg) {
			exec->m_ProgressDlg.SetFileName(ArchivedFile->FileData->SourceFileName); 
		}
		{
			// fBNgEgo[TE`FbN
			CString strFileName = ArchivedFile->FileData->SourceFileName;
			if (strFileName.Find(":") > -1 ||
				strFileName.Find("..") > -1) {
				switch (exec->m_OptEA) {
				case 0:	// Sċ
					break;
				case 1:	// _CAOŃ[U[ɖ₢킹
					switch (WTL::AtlMessageBox(_Module.g_ParenthWnd, IDS_ASK_DTV, "UnAceV2J.DLL", MB_OKCANCEL | MB_ICONEXCLAMATION | MB_DEFBUTTON2)) {
					case IDOK:
						break;
					case IDCANCEL:
						return ACE_CALLBACK_RETURN_NO;
					}
					break;
				case 2:	// Sċ֎~
					return ACE_CALLBACK_RETURN_NO;
				default:
					return ACE_CALLBACK_RETURN_NO;
				}
			}

			CString s;
			s.Format(CTools::LoadString(IDS_EXTRACTING), ArchivedFile->FileData->SourceFileName);
			exec->m_Output += s;
			if (ArchivedFile->FileData->Size == 0) {
				exec->m_Output += CTools::LoadString(IDS_EXTRACTING_DIR);
			}
			return ACE_CALLBACK_RETURN_OK;
		}
		break;
	default:
		strAction = "unknown operation on";
		break;
	}
	
	return ACE_CALLBACK_RETURN_OK;
}

INT CExecute::HandleErrorGlobal(pACECallbackGlobalStruc Error)
{
	CString   strError;
	INT       Result;
	CExecute *exec = (CExecute *)Error->GlobalData->Obj;
	
	Result = ACE_CALLBACK_RETURN_OK;
	
	switch (Error->Code) {
	case ACE_CALLBACK_ERROR_MEMORY:
		strError = CTools::LoadString(IDS_NOT_ENOUGH_MEMOPRY);
		break;
	case ACE_CALLBACK_ERROR_UNCSPACE:
		strError = CTools::LoadString(IDS_COULD_NOT_DETECT);
		break;
	default:
		strError = CTools::LoadString(IDS_UNKNOWN);
		Result = ACE_CALLBACK_RETURN_CANCEL;
		break;
	}
	CString strWork;
	strWork.Format(CTools::LoadString(IDS_ERROR), strError);
	exec->m_Output += strWork;

	return Result;
}

INT CExecute::HandleErrorArchive(pACECallbackArchiveStruc Error)
{
	CString   strError;
	INT       Result;
	BOOL      DoPrompt;
	CExecute *exec = (CExecute *)Error->GlobalData->Obj;
	
	Result   = ACE_CALLBACK_RETURN_OK;
	DoPrompt = 0;
	
	switch (Error->Code) {
	case ACE_CALLBACK_ERROR_AV:
		strError = CTools::LoadString(IDS_AV_OF_ARCHIVE_INVALID);
		break;
	case ACE_CALLBACK_ERROR_OPENARCHIVEREAD:
		strError = CTools::LoadString(IDS_COUDL_NOT_OPEN_ARCHIVE);
		break;
	case ACE_CALLBACK_ERROR_READARCHIVE:
		strError = CTools::LoadString(IDS_ERROR_READING_FROM_ARCHIVE);
		break;
	case ACE_CALLBACK_ERROR_ARCHIVEBROKEN:
		strError = CTools::LoadString(IDS_ARCHIVE_IS_BROKEN);
		break;
	case ACE_CALLBACK_ERROR_NOFILES:
		strError = CTools::LoadString(IDS_NO_FILES_SPECIFIED);
		break;
	case ACE_CALLBACK_ERROR_ISNOTANARCHIVE:
		strError = CTools::LoadString(IDS_NOT_AN_ACE_ARCHIVE);
		break;
	case ACE_CALLBACK_ERROR_HIGHERVERSION:
		strError = CTools::LoadString(IDS_NOT_ABLE_TO_HANDLE);
		break;
	default:
		strError = CTools::LoadString(IDS_UNKNOWN);
		Result   = ACE_CALLBACK_RETURN_CANCEL;
		break;
	}
	
	if (DoPrompt) {
		return UserPrompt(strError, Error->ArchiveData->ArchiveName, 0);
	} else {
		exec->m_Output += CTools::LoadString(IDS_ERROR);
		CString strWork;
		strWork.Format(strError, Error->ArchiveData->ArchiveName);
		exec->m_Output += strWork;
		exec->m_Output += "\n";
		
		return Result;
	}
}

INT CExecute::HandleErrorArchivedFile(pACECallbackArchivedFileStruc Error)
{
	CString   strError;
	INT       Result;
	CExecute *exec = (CExecute *)Error->GlobalData->Obj;
	
	Result   = ACE_CALLBACK_RETURN_OK;
	
	switch (Error->Code) {
	case ACE_CALLBACK_ERROR_CREATIONNAMEINUSE:
		strError = CTools::LoadString(IDS_ERROR_CREATIONNAMEINUSE);
		break;
	case ACE_CALLBACK_ERROR_WRITE:
		strError = CTools::LoadString(IDS_ERROR_WRITE);
		break;
	case ACE_CALLBACK_ERROR_OPENWRITE:
		strError = CTools::LoadString(IDS_ERROR_OPENWRITE);
		break;
	case ACE_CALLBACK_ERROR_METHOD:
		strError = CTools::LoadString(IDS_ERROR_METHOD);
		break;
	case ACE_CALLBACK_ERROR_EXTRACTSPACE:
		strError = CTools::LoadString(IDS_ERROR_EXTRACTSPACE);
		break;
	case ACE_CALLBACK_ERROR_CREATION:
		strError = CTools::LoadString(IDS_ERROR_CREATION);
		break;
	default:
		strError = CTools::LoadString(IDS_UNKNOWN);
		Result   = ACE_CALLBACK_RETURN_CANCEL;
		break;
	}
	
	exec->m_Output += "\nError: ";
	CString strWork;
	strWork.Format(strError, Error->FileData->SourceFileName);
	exec->m_Output += strWork;
	exec->m_Output += "\n";
	
	return Result;
}

INT CExecute::HandleErrorRealFile(pACECallbackRealFileStruc Error)
{
	CString   strError;
	INT       Result;
	CExecute *exec = (CExecute *)Error->GlobalData->Obj;
	
	Result   = ACE_CALLBACK_RETURN_OK;
	
//	switch (Error->Code) {
//	default:
		strError = "unknown";
		Result   = ACE_CALLBACK_RETURN_CANCEL;
//	}
	
	exec->m_Output += "\nError: ";
	CString strWork;
	strWork.Format(strError, Error->FileName);
	exec->m_Output += strWork;
	exec->m_Output += "\n";
	
	return Result;
}

INT CExecute::HandleErrorSpace(pACECallbackSpaceStruc Error)
{
	CString   strError;
	INT       Result;
	CExecute *exec = (CExecute *)Error->GlobalData->Obj;
	
	strError = "";
	Result   = ACE_CALLBACK_RETURN_OK;
	
//	switch (Error->Code) {
//	default:
		strError = "unknown";
		Result   = ACE_CALLBACK_RETURN_CANCEL;
//	}
	
	exec->m_Output += "\nError: ";
	CString strWork;
	strWork.Format(strError, Error->Directory);
	exec->m_Output += strWork;
	exec->m_Output += "\n";
	
	return Result;
}

INT CExecute::HandleErrorSFXFile(pACECallbackSFXFileStruc Error)
{
	CString   strError;
	INT       Result;
	CExecute *exec = (CExecute *)Error->GlobalData->Obj;
	
	strError = "";
	Result   = ACE_CALLBACK_RETURN_OK;
	
//	switch (Error->Code) {
//	default:
		strError = "unknown";
		Result   = ACE_CALLBACK_RETURN_CANCEL;
//	}
	
	exec->m_Output += "\nError: ";
	CString strWork;
	strWork.Format(strError, Error->SFXFileName);
	exec->m_Output += strWork;
	exec->m_Output += "\n";
	
	return Result;
}

INT CExecute::HandleRequestGlobal(pACECallbackGlobalStruc Request)
{
	CExecute *exec = (CExecute *)Request->GlobalData->Obj;
//	switch (Request->Code) {
//	default:
		exec->m_Output += "\nunknown request\n";
		return ACE_CALLBACK_RETURN_CANCEL;
//	}
	
	return ACE_CALLBACK_RETURN_CANCEL;
}

INT CExecute::HandleRequestArchive(pACECallbackArchiveStruc Request)
{
	CString     strRequest;
	CExecute *exec = (CExecute *)Request->GlobalData->Obj;
	
	strRequest = "";
	
	switch (Request->Code) {
	case ACE_CALLBACK_REQUEST_CHANGEVOLUME:
		strRequest = "ready to process next volume %s";
		break;
	default:
		exec->m_Output += "\nunknown request\n";
		return ACE_CALLBACK_RETURN_CANCEL;
	}
	
	return UserPrompt(strRequest, Request->ArchiveData->ArchiveName, 1);
}

INT CExecute::HandleRequestArchivedFile(pACECallbackArchivedFileStruc Request)
{
	CString     strRequest;
	CExecute *exec = (CExecute *)Request->GlobalData->Obj;
	
	strRequest = "";
	
	switch (Request->Code) {
	case ACE_CALLBACK_REQUEST_OVERWRITE:
		{
			if (exec->m_Overwrite || exec->m_AllYes) {
				return ACE_CALLBACK_RETURN_OK;
			}
			if (exec->m_AllNo) {
				exec->m_Output += "  Skipped\n";
				return ACE_CALLBACK_RETURN_NO;
			}
			if (exec->m_RequestAll != -1) {
				switch (exec->m_RequestAll) {
				case ACE_CALLBACK_RETURN_NO:
					exec->m_Output += "  Skipped\n";
					break;
				case ACE_CALLBACK_RETURN_OK:
					break;
				}
				return exec->m_RequestAll;
			}
			CString strFileName = Request->FileData->SourceFileName;
			if (exec->m_ExcludePath) {
				// fBNg菜
				for (int i = 1; i < strFileName.GetLength(); i++) {
					if (strFileName.GetAt(strFileName.GetLength() - i) == '\\') {
						strFileName.Right(i - 1); 
						break;
					}
				}
			}
			CString s;
			s = exec->m_BaseDir;
			s += strFileName;

			CConfirmation dlg;
			dlg.SetFileInfo(Request->FileData->SourceFileName,
							Request->FileData->Size,
							Request->FileData->Time,
							s);
			// ㏑mF_CAO\B
			switch (dlg.DoModal()) {
			case IDB_NO:
				exec->m_RequestAll = -1;
				exec->m_Output += "  Skipped\n";
				return ACE_CALLBACK_RETURN_NO;
			case IDB_NO_ALL:
				exec->m_RequestAll = ACE_CALLBACK_RETURN_NO;
				exec->m_Output += "  Skipped\n";
				return ACE_CALLBACK_RETURN_NO;
			case IDB_YES:
				exec->m_RequestAll = -1;
				return ACE_CALLBACK_RETURN_OK;
			case IDB_YES_ALL:
				exec->m_RequestAll = ACE_CALLBACK_RETURN_OK;
				return ACE_CALLBACK_RETURN_OK;
			case IDCANCEL:
			default:
				exec->m_RequestAll = -1;
				exec->m_Output += "  Skipped\n";
				return ACE_CALLBACK_RETURN_CANCEL;
			}
		}
//		strRequest = "overwrite existing file %s";
		break;
	case ACE_CALLBACK_REQUEST_PASSWORD:
		{
			if (exec->m_Password.GetLength() > 0) {
				Request->GlobalData->DecryptPassword = CStringToLPSTR(exec->m_Password);
				return ACE_CALLBACK_RETURN_OK;
			}
			// pX[h_CAO\
			CPassDlg dlg;
			if (dlg.DoModal() == IDOK) {
				exec->m_Password = dlg.m_Password;
				Request->GlobalData->DecryptPassword = CStringToLPSTR(exec->m_Password);
				return ACE_CALLBACK_RETURN_OK;
			} else {
				return ACE_CALLBACK_RETURN_CANCEL;
			}
			break;
		}
	default:
		exec->m_Output += "\nunknown request\n";
		return ACE_CALLBACK_RETURN_CANCEL;
	}
	
	return UserPrompt(strRequest, Request->FileData->SourceFileName, 1);
}

INT CExecute::HandleRequestRealFile(pACECallbackRealFileStruc Request)
{
	CExecute *exec = (CExecute *)Request->GlobalData->Obj;
//	LPSTR     RequestStr;
	
//	RequestStr = "";
	
//	switch (Request->Code) {
//	default:
		exec->m_Output += "\nunknown request\n";
		return ACE_CALLBACK_RETURN_CANCEL;
//	}
	
//	return UserPrompt(RequestStr, Request->FileName, 1);
}

INT CExecute::UserPrompt(CString strPrompt, CString Param, BOOL IsRequest)
{
	CString strMsg;
	UINT uiType;

	if (IsRequest) {
		strMsg = "Request: ";
		uiType = MB_YESNOCANCEL | MB_ICONEXCLAMATION;
	} else {
		strMsg = "Error: ";
		uiType = MB_OKCANCEL | MB_ICONEXCLAMATION;
	}
	CString s;
	s.Format(strPrompt, Param);
	strMsg += s;

	switch (::MessageBox(_Module.g_ParenthWnd, strMsg, "UnAceV2J.DLL", uiType)) {
	case IDYES:
	case IDOK:
		return ACE_CALLBACK_RETURN_OK;
	case IDNO:
		return ACE_CALLBACK_RETURN_NO;
	}
	return ACE_CALLBACK_RETURN_CANCEL;
}

INT CExecute::Open(CString strArcFile, CString strWildName, void *Obj)
{
	tACEReadArchiveDataStruc ArchiveData;

	m_Open = TRUE;
	m_ShowDlg = FALSE;
	m_FileCount = 0;
	m_Obj = Obj;

	INT iResult = 0;
	m_Output = "";

	if (!LoadAceDll()) {
		m_Open = FALSE;
		return -1;
	}

	m_FileList = strWildName;

	CallAceInitDll();

	strArcFile = CTools::RemoveQuoteFileName(strArcFile);

	BOOL bExists = CTools::FileExists(strArcFile);
	if (!bExists) {
		m_Open = FALSE;
		return -1;
	}
	LPTSTR pArcFile = CStringToLPSTR(strArcFile);
	ACEReadArchiveDataProc(pArcFile , &ArchiveData);
	if (!ArchiveData.ArchiveData) {
		FreeLoadAceDll();
		m_Open = FALSE;
		return -1;
	}
	iResult = CallACEList(pArcFile);
	FreeLoadAceDll();

	m_Open = FALSE;
	return iResult;
}

BOOL CExecute::CheckArchive(LPCSTR szFileName)
{
	CString strArcFile = szFileName;
	tACEReadArchiveDataStruc ArchiveData;

	m_Open = FALSE;
	m_ShowDlg = FALSE;
	m_FileCount = 0;

	INT iResult = 0;
	m_Output = "";

	if (!LoadAceDll()) {
		m_Open = FALSE;
		return FALSE;
	}

	m_FileList = "*";

	CallAceInitDll();

	strArcFile = CTools::RemoveQuoteFileName(strArcFile);

	BOOL bExists = CTools::FileExists(strArcFile);
	if (!bExists) {
		m_Open = FALSE;
		return FALSE;
	}
	LPTSTR pArcFile = CStringToLPSTR(strArcFile);
	ACEReadArchiveDataProc(pArcFile , &ArchiveData);
	if (!ArchiveData.ArchiveData) {
		FreeLoadAceDll();
		m_Open = FALSE;
		return FALSE;
	} else {
		FreeLoadAceDll();
		m_Open = FALSE;
		return TRUE;
	}
}

INT CExecute::GetFileCount(LPCSTR szFileName)
{
	CString strArcFile = szFileName;
	tACEReadArchiveDataStruc ArchiveData;

	m_Open = FALSE;
	m_ShowDlg = FALSE;
	m_FileCount = 0;

	INT iResult = 0;
	m_Output = "";

	if (!LoadAceDll()) {
		m_Open = FALSE;
		return -1;
	}

	m_FileList = "*";

	CallAceInitDll();

	strArcFile = CTools::RemoveQuoteFileName(strArcFile);

	BOOL bExists = CTools::FileExists(strArcFile);
	if (!bExists) {
		m_Open = FALSE;
		return -1;
	}
	LPTSTR pArcFile = CStringToLPSTR(strArcFile);
	ACEReadArchiveDataProc(pArcFile , &ArchiveData);
	if (!ArchiveData.ArchiveData) {
		FreeLoadAceDll();
		m_Open = FALSE;
		return -1;
	}
	iResult = CallACEList(pArcFile);
	FreeLoadAceDll();

	m_Open = FALSE;
	if (iResult == 0) {
		return m_FileCount;
	} else {
		return -1;
	}
}

INT CExecute::ConvertAceErr(INT iErrorCode)
{
	switch (iErrorCode) {
    case ACE_ERROR_NOERROR:
		// no error; operation succesful
		return 0;
		break;
	case ACE_ERROR_MEM:
		// insufficient memory
		return ERROR_MORE_HEAP_MEMORY;
		break;
	case ACE_ERROR_FILES:
		// no files specified
		return ERROR_NOT_ARC_FILE;
		break;
	case ACE_ERROR_FOUND:
		// specified archive not found
		return ERROR_NOT_FIND_ARC_FILE;
		break;
	case ACE_ERROR_FULL:
		// disk full
		return ERROR_DISK_SPACE;
		break;
	case ACE_ERROR_OPEN:
		// could not open file
		return ERROR_FILE_OPEN;
		break;
	case ACE_ERROR_READ:
		// read error
		return ERROR_CANNOT_READ;
		break;
	case ACE_ERROR_WRITE:
		// write error
		return ERROR_CANNOT_WRITE;
		break;
	case ACE_ERROR_CLINE:
		// invalid command line
		return ERROR_COMMAND_NAME;
		break;
	case ACE_ERROR_CRC:
		// CRC error
		return ERROR_HEADER_CRC;
		break;
	case ACE_ERROR_OTHER:
		// other error
		return -1;
		break;
	case ACE_ERROR_EXISTS:
		// file already exists
		return ERROR_ALREADY_EXIST;
		break;
	case ACE_ERROR_USER:
		// user break (application
        // returned cancel code at
        // callback function)
		return ERROR_USER_SKIP;
		break;
	default:
		break;
	}
	return -1;
}


UINT CExecute::GetOSType()
{
	return m_OSType;
}
