#pragma once

#include "ProgressDlg.h"
#include "UnAce/unace.h"
#include "ArchiveFileInfo.h"
#include <imagehlp.h>
#pragma comment (lib,"imagehlp.lib")

#define   COMMENTBUFSIZE 8192   // comments may be up to 32k in size
                                // increase it if you want to put that
                                // large comments to archives, or if
                                // you want to receive all of these large
                                // comments (ACE_COMMENT_SMALLBUF returned
                                // if comment does not fit into buffer)

#define CStringToLPSTR(a) const_cast<LPTSTR>(static_cast<LPCTSTR>(a))

class CExecute
{
public:
	UINT GetOSType();
	INT GetFileCount(LPCSTR szFileName);
	BOOL CheckArchive(LPCSTR szFileName);
	INT Open(CString strArcFile, CString strWildName, void *Obj);
	static INT CALLBACK StateProc(pACEStateCallbackProcStruc State);
	static INT CALLBACK RequestProc(pACERequestCallbackProcStruc Request);
	static INT CALLBACK ErrorProc(pACEErrorCallbackProcStruc Error);
	static INT CALLBACK InfoProc(pACEInfoCallbackProcStruc Info);
	CString GetOutput();
	DWORD SetCommand(CString strCmdLine);
	CExecute(void);
	CExecute(const HWND _hwnd);
	~CExecute(void);

private:
	INT m_OptEA;
	void  * m_Obj;
	BOOL m_Overwrite;
	BOOL m_AllYes;
	BOOL m_AllNo;
	BOOL m_FullPathMatching;
	INT m_RequestAll;
	BOOL m_ExcludePath;
	CString m_BaseDir;
	UINT m_OSType;
	INT m_FileCount;
	INT ConvertAceErr(INT iErrorCode);
	CProgressDlg m_ProgressDlg;
	CString m_Password;
	BOOL m_Open;
	BOOL m_ShowDlg;
	CString m_Output;
	INT (__stdcall *ACEInitDllProc)(pACEInitDllStruc DllData);
	INT (__stdcall *ACEReadArchiveDataProc)(LPSTR ArchiveName, pACEReadArchiveDataStruc ArchiveData);
	INT (__stdcall *ACEListProc)(LPSTR ArchiveName, pACEListStruc List);
	INT (__stdcall *ACETestProc)(LPSTR ArchiveName, pACETestStruc Test);
	INT (__stdcall *ACEExtractProc)(LPSTR ArchiveName, pACEExtractStruc Extract);

	CString m_FileList;
	CHAR CommentBuf[COMMENTBUFSIZE];

	static INT UserPrompt(CString strPrompt, CString Param, BOOL IsRequest);
	static INT HandleRequestRealFile(pACECallbackRealFileStruc Request);
	static INT HandleRequestArchivedFile(pACECallbackArchivedFileStruc Request);
	static INT HandleRequestArchive(pACECallbackArchiveStruc Request);
	static INT HandleRequestGlobal(pACECallbackGlobalStruc Request);
	static INT HandleErrorSFXFile(pACECallbackSFXFileStruc Error);
	static INT HandleErrorSpace(pACECallbackSpaceStruc Error);
	static INT HandleErrorRealFile(pACECallbackRealFileStruc Error);
	static INT HandleErrorArchivedFile(pACECallbackArchivedFileStruc Error);
	static INT HandleErrorArchive(pACECallbackArchiveStruc Error);
	static INT HandleErrorGlobal(pACECallbackGlobalStruc Error);
	static INT HandleStateStartFile(pACECallbackArchivedFileStruc ArchivedFile);
	static INT HandleStateStartArchive(pACECallbackArchiveStruc Archive);
	INT CallACEExtract(LPSTR ArchiveName, LPSTR DestinationDir, BOOL DoExcludePath);
	INT CallACETest(LPSTR ArchiveName);
	INT CallACEList(LPSTR ArchiveName);
	void CallAceInitDll(void);
	void PrintHelp(void);
	void FreeLoadAceDll(void);
	HINSTANCE m_AceDllInstance;
	BOOL LoadAceDll(void);
	CString m_DlgInfo;
	BOOL m_CmdL;
};

