#pragma once

#include "UnAceV2J.h"
#include "ArchiveFileInfo.h"

class COpenArchive
{
public:
//	CObList m_list;
	CAtlList<CArchiveFileInfo *> m_list;
	void Close();
	int GetFileCount(void);
	BOOL GetCompressedSizeEx(ULHA_INT64* lpllSize);
	BOOL GetOriginalSizeEx(ULHA_INT64* lpllSize);
	BOOL GetArcCompressedSizeEx(ULHA_INT64* lpllSize);
	BOOL GetArcOriginalSizeEx(ULHA_INT64* lpllSize);
	BOOL GetArcFileSizeEx(ULHA_INT64* lpllSize);
	BOOL GetArcWriteTimeEx(FILETIME* lpftLastWriteTime);
	BOOL GetArcAccessTimeEx(FILETIME* lpftLastAccessTime);
	BOOL GetArcCreateTimeEx(FILETIME* lpftCreationTime);
	BOOL GetAccessTimeEx(FILETIME *lpftLastAccessTime);
	BOOL GetCreateTimeEx(FILETIME *lpftLastCreateTime);
	BOOL GetWriteTimeEx(FILETIME* lpftLastWriteTime);
	DWORD GetAccessTime(void);
	DWORD GetCreateTime(void);
	DWORD GetWriteTime(void);
	int GetMethod(LPSTR lpBuffer, const int nSize);
	UINT GetOSType(void);
	int GetAttribute(void);
	DWORD GetCRC(void);
	WORD GetTime(void);
	WORD GetDate(void);
	WORD GetRatio(void);
	DWORD GetCompressedSize(void);
	DWORD GetOriginalSize(void);
	int GetFileName(LPSTR lpBuffer, const int nSize);
	int IsSFXFile(void);
	UINT GetArcOSType(void);
	WORD GetArcTime(void);
	WORD GetArcDate(void);
	WORD GetArcRatio(void);
	DWORD GetArcCompressedSize(void);
	DWORD GetArcOriginalSize(void);
	DWORD GetArcFileSize(void);
	int GetArcFileName(LPSTR lpBuffer, const int nSize);
	int FindNext(INDIVIDUALINFO *lpSubInfo);
	int FindFirst(LPCSTR lpszWildName, INDIVIDUALINFO *lpSubInfo);
	BOOL Open(const HWND _hwnd, LPCSTR lpFileName, DWORD dwMode);
	static void RemoveAll(void);
	static COpenArchive* FindObject(HARC hArc);
	COpenArchive();
	virtual ~COpenArchive();
	COpenArchive* m_pOAPrev;
	COpenArchive* m_pOANext;

protected:
	BOOL m_IsSFX;

	CString m_WildName;

	CString m_ArcFileName;
	UINT64 m_ui64ArcCompressedSize;
	UINT64 m_ui64ArcOriginalSize;

	POSITION m_aItemPos;
	CString m_aFileName;
	UINT64 m_ui64OriginalSize;
	UINT64 m_ui64CompressedSize;
	FILETIME m_ftLastCreateTime;
	FILETIME m_ftLastAccessTime;
	FILETIME m_ftLastWriteTime;
	DWORD m_dwCRC;
	DWORD m_dwAttribute;
	DWORD m_dwMode;
	CString m_aMode;
	UINT32 m_aNumItems;

	WIN32_FIND_DATA m_fdArchive;
	BOOL m_bSearchMode;
private:
	UINT m_aOSType;
};

