#include "StdAfx.h"
#include "Tools.h"


CTools::CTools(void)
{
}


CTools::~CTools(void)
{
}

int CTools::SplitCommandLine(CString strCmdLine, CStringList * argv)
{
	BOOL bStart = FALSE;
	BOOL bQuote = FALSE;
	int iStart = 0;

	// ÕXy[X菜B
	strCmdLine.TrimRight();
	strCmdLine.TrimLeft();
	
	strCmdLine += " ";
	for (int i = 0; i < strCmdLine.GetLength(); i++) {
		switch (strCmdLine.GetAt(i)) {
		case '\"':
			bQuote = !bQuote;
			break;
		case ' ':
		case '\t':
		case '\n':
			if (!bQuote) {
				CString strArgv = ((LPCTSTR)strCmdLine.Mid(iStart, i - iStart));
				strArgv.TrimRight();
				if (strArgv.GetLength() > 0) {
					argv->AddTail(strArgv); 	
				}
				iStart = i + 1;
			}
			break;
		default:
			break;
		}
	}
	return (int)argv->GetCount(); 
}

BOOL CTools::FileExists(CString strFileName)
{
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	BOOL bResult = FALSE;
	CString strFile = RemoveQuoteFileName(strFileName);

	hFind = ::FindFirstFile(strFile, &FindFileData);
	if (hFind == INVALID_HANDLE_VALUE) {
		bResult = FALSE;
	} else {
		if (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
			bResult = FALSE;
		} else {
			bResult = TRUE;
		}
		::FindClose(hFind);
	}
	return bResult;
}

CString CTools::RemoveQuoteFileName(CString strFileName)
{
	CString strArgv = strFileName;
	strArgv.TrimLeft();
	strArgv.TrimRight(); 
	if (strArgv.GetAt(0) == '"' &&
		strArgv.GetAt(strArgv.GetLength() - 1) == '"') {
		strArgv.TrimLeft("\"");
		strArgv.TrimRight("\"");
	}
	return strArgv;
}

CString CTools::AddQuoteFileName(CString strFileName)
{
	CString strResult;

	if (strFileName.FindOneOf(" ") > 0) {
		if (strFileName.Left(0) != '\"') {
			strResult += "\"";
			strResult += strFileName;
			strResult += "\"";
		} else {
			strResult = strFileName;
		}
	} else {
		strResult = strFileName;
	}
	return strResult;
}

//	ChJ[hɑΉt@C̔r
//	*: 0ȏ
//	?: 1
//	char*	test;		t@C	ex."ABCDE.FGH"
//	char*	pattern;	p^[		ex."ABC*.*"
//	BOOL	߂l		1:vĂ 0:vĂȂ
BOOL CTools::IsMatch(const char *test, const char *pattern)
{
//	printf("Filename_compare(%s %s)\n", test,pattern);

	//	p^[̍ŏ̕ɂꍇ
	switch( *pattern ) 
	{
	case '\0':
		//	p^[̂ƂAt@CȂ(TRUE)B
		//	łȂȂA(FALSE)ԂB
		return *test == '\0';
	case '*':
		//	* ̂ƂA *ȍ~̕ƁAǂݔ΂
		//	t@CŔrBAȍ~vĂ
		//	Ȃ(TRUE)ԂB
		for( ;*test!='\0'; test++)
		{
			if( IsMatch(test, pattern+1) ) return TRUE;
		}
		//	ɗƂAtestׂ͂ēǂݔ΂ĂB
		//	* ̌ɕȂ΁AȂ̂(TRUE)ԂB
		//	* ̌ɕcĂ΁AvȂƂɂȂA
		//	(FALSE)ԂB
		return *(pattern+1) == '\0';
	case '?':
		//	? ̂ƂAꂼPǂݔ΂ArB
		return IsMatch(test+1,pattern+1);
	default:
		//	ChJ[hȊO̒ʏ̂̕Ƃɂ́A啶
		//	ĔrBĂ(FALSE)ԂB
		if( toupper(*pattern) != toupper(*test) ) return FALSE;
		//	ȂA̕rB
		return IsMatch(test+1,pattern+1);
	}
	//	ɗ邱Ƃ͂ȂB
}

CString CTools::LoadString(UINT nID)
{
	CString s;
	if (! s.LoadString(nID)) {
		ATLTRACE2("Error Loading String:%d\n", nID);
		s = "";
	}
	return s;
}

CString CTools::OmitPath(WTL::CStatic *lblStatic, CString strPath)
{
	RECT rc;
	CString strResult = strPath;
	HDC hDC = ::GetDC(lblStatic->m_hWnd); 
	::GetWindowRect(lblStatic->m_hWnd, &rc);
	int iResult = ::DrawTextEx(hDC, 
							   strResult.GetBuffer(0), 
							   strResult.GetLength(), 
							   &rc, 
							   DT_CALCRECT | DT_MODIFYSTRING | DT_NOPREFIX | DT_PATH_ELLIPSIS | DT_SINGLELINE, 
							   NULL);  
	strResult.ReleaseBuffer();
	::ReleaseDC(lblStatic->m_hWnd, hDC); 
	if (iResult != 0) {
		ATLTRACE2("OmitPath: %s\n", strResult);
		return strResult;
	} else {
		return strPath;
	}
}

CString CTools::GetCurrentDir()
{
	char chPath[MAX_PATH];
	if (::GetCurrentDirectory(MAX_PATH, chPath) == 0) {
		// s
		return "";
		// 肦ȂƎv...B
	}
	return chPath;
}
